\ 	$Id: 32bit64bit.fs,v 1.2 2009-10-22 07:41:15 f Exp $

\ ****************************************************************
\ Comparisons ( = > < 0> 0< etc ) can give other results when 32bit
\ sessions run on 64bit machines, i.e. after 32bit overflow.
\ This is an attempt to cure the matter.

\ ****************************************************************
[DEFINED] 32bit-64 [IF] \ Compile words to deal with 32bit data on 64bit system
    get-current		\ VOCABULARY 32-64-words
    VOCABULARY 32-64-words also 32-64-words definitions
    hex

    \ Comparison words that will be used to build gene primitives for old
    \ benchmarks recorded on 32bit systems being played on a 64 bit system.

    : 0= ( u -- flag )   FFFFFFFF and 0= ;	\ throw away higher bits

    : 0<32bit ( u -- flag )   80000000 and ;	\ flag not normalized

    : 0< ( u -- flag )   0<32bit IF true ELSE false THEN ;

    : 32>64bit ( u -- n )
	dup 80000000 and IF			\ 0<32bit (inlined)
	    FFFFFFFF00000000 or			\ regard it as negative
	ELSE
	    FFFFFFFF and			\ regard it as positive
	THEN ;

    : 0> ( u -- flag )   32>64bit 0> ;

    : 0< ( u -- flag )   32>64bit 0< ;
    
    : 32>64bit-twice ( n1-32bit  n2-32bit -- n1-64bit n2-64bit )
	swap 32>64bit swap 32>64bit ;

    : = ( n1 n2 -- flag )   32>64bit-twice = ;

    : > ( n1 n2 -- flag )   32>64bit-twice > ;

    : < ( n1 n2 -- flag )   32>64bit-twice < ;

    : within ( n1 n2 n3 -- flag )   >r  32>64bit-twice  r> 32>64bit  within ;

    decimal
    previous set-current
[THEN]
