\ generic-scans.fs

0 VALUE (generic-scan-data)	\ will be in a field

' (generic-scan-data) 0
BASE+OFFSET: generic-detail-xt	  \ i.e. organ-A B-parameter score 
BASE+OFFSET: generic-fetch-xt	  \ i.e. noop @ df@
\ BASE+OFFSET: generic-detail-type  \ i.e. type-int% type-df% type-int-addr%
BASE+OFFSET: generic-fetched-type \ i.e. type-int% type-df%
BASE+OFFSET: generic-locality	  \ i.e. nuc-local% spot-local%
BASE+OFFSET: generic-loop-xt	\ i.e. EXECUTE do-with-everybody do-everywhere

\ prescan data:
dup -rot

BASE+OFFSET: prescan-process-1-xt		\ prescan, read one item in
BASE+OFFSET: prescan-count
maxaligned BASE+OFFSET: prescan-min
maxaligned BASE+OFFSET: prescan-max
maxaligned BASE+OFFSET: prescan-average	\ double maxaligned cells for sum
1+ maxaligned

rot over swap - CONSTANT prescan-data-size#

CONSTANT scan-data-size#
drop

: prescan-sum ( -- addr )   prescan-average ; \ just an alias during prescan


scan-data-size# allocate THROW to (generic-scan-data)

: set-fetching ( fetch-xt fetched-type -- )
    generic-fetched-type !
    generic-fetch-xt ! ;

: set-locality ( locality-code -- )
    dup generic-locality !
    CASE
	nuc-local% OF
	    ['] do-with-everybody generic-loop-xt !
	    EXIT
	ENDOF
	spot-local%	OF
	    ['] do-everywhere generic-loop-xt !
	    EXIT
	ENDOF
	ABORT
    ENDCASE ;

: +count ( -- )   1 prescan-count +! ;

: prescan-fetch&store-1 ( -- )
    generic-detail-xt @ EXECUTE
    generic-fetch-xt @ EXECUTE
    prescan-process-1-xt @ EXECUTE
    +count ;

: prescan-process-int ( n -- )
    >r

    r@ s>d  prescan-sum  dup >r  2@ d+ r> 2!	\ sum up
    r@ prescan-max  dup >r  @  max  r> !	\ max
    r> prescan-min  dup >r  @  min  r> ! ;	\ min

: init-prescan ( -- )
    prescan-process-1-xt prescan-data-size# erase

    generic-fetched-type @ CASE
	type-int% OF
	    ['] prescan-process-int prescan-process-1-xt !
	    \ 0 prescan-count !
	    highest-integer# prescan-min !
	    lowest-integer#  prescan-max !
	    \ 0 0 prescan-sum 2!
	    EXIT
	ENDOF
	ABORT
    ENDCASE
    ;

: compute-average ( -- )
    generic-fetched-type @ CASE
	type-int% OF DADA
	    prescan-sum 2@
	    2dup d0= IF
		2drop
		0e0 prescan-average df!
		EXIT
	    THEN

	    d>f  prescan-count @ s>f  f/
	    prescan-average df!
	    EXIT
	ENDOF
    ENDCASE
    ABORT ;

: prescan ( -- )
    init-prescan
    ['] prescan-fetch&store-1  generic-loop-xt @  EXECUTE
    compute-average ;

: set-int-var ( xt -- )
    generic-detail-xt !
    ['] @  type-int% set-fetching ;

: set-nuc-int-var ( xt -- )   set-int-var  nuc-local% set-locality ;

: set-spot-int-var ( xt -- )   set-int-var  spot-local% set-locality ;


: set-int-funct ( xt -- )
    generic-detail-xt !
    ['] noop  type-int% set-fetching ;

: set-nuc-int-funct ( xt -- )   set-int-funct  nuc-local% set-locality ;

: set-spot-int-funct ( xt -- )   set-int-funct  spot-local% set-locality ;


true [if] \ testing

    : .xt ( xt -- )
	dup 0= IF ." uninitialized xt" drop EXIT THEN
	xt>string type ;

    : .scandata ( -- )
	generic-detail-xt @	cr ." generic-detail-xt    " .xt
	generic-fetch-xt @	cr ." generic-fetch-xt     " .xt
	\ generic-detail-type @   cr ." generic-detail-type  " .
	generic-fetched-type @	cr ." generic-fetched-type " .
	generic-locality @	cr ." generic-locality     " .
	generic-loop-xt @	cr ." generic-loop-xt      " .xt
	prescan-process-1-xt @	cr ." prescan-process-1-xt " .xt
	prescan-count @		cr ." prescan-count        " .
	prescan-min @		cr ." prescan-min          " .
	prescan-max @		cr ." prescan-max          " .
	prescan-average df@	cr ." prescan-average      " f.
    ;

    : ttt
	page
	['] organ-A set-nuc-int-var
	prescan
	.scandata
	;

[then]
