\ linear-2-float.fs

\ ****************************************************************
\ ***************  simple linear equation system  ****************
\ ****************************************************************

\ Compile only if the needed variables are defined:
nuc-f-organs# 1 >  spot-f-properties# 2 >  AND [IF]

\ Let's test a simple linear equation system of the form
\ A + c*B = 0
\ A + d*B + e = 0

\ Brew should find A and B.
\ We rate on the added absolute miss of the two equations.

\ The cells have to find out to put the solutions x and y in
\ their first two organs.

\ Parameters c, d, e are spot properties.
\ They will be set randomly each time before the cell is activated.
\ So on each life step the conditions will change heavily and the
\ cells have to find out how to adjust A and B (inner float organs A and B )
\ accordingly.


\ So we have:
\ A + c*B = 0
\ A + d*B + e = 0

\ brew sees it like this:
\ x = f-organ-A		y = f-organ-B				\ r/w nuc vars
\ c = C-f-property	d = D-f-property     e = E-f-property	\ r/o spot vars

\ f-organ-A df@  C-f-property df@ f-organ-B df@ f*  f+		 	    =0
\ f-organ-A df@  D-f-property df@ f-organ-B df@ f*  f+  E-f-property df@ d+ =0
\ 
\ a possible solution ;-)
\ A = ce / (d - c)
\ B = e  / (c - d)
\ 
s" -" GENE: cheat-linear-2-float
    C-f-property@ E-f-property@ f*  D-f-property@ C-f-property@ f-  f/
    f-organ-A df!
    E-f-property@  C-f-property@ D-f-property@ f-  f/  f-organ-B df! ;gene

internal' cheat-linear-2-float wake-me-actions >list

: linear-2-float-error ( -- +n )
    f-organ-A df@  f-organ-B df@  C-f-property@ f*  f+
    fabs-replace-NaN
    f-organ-A df@  f-organ-B df@  D-f-property@ f*  f+  E-f-property@ f+
    fabs-replace-NaN
    f+ f>s-limited ;

: score-linear-2-float ( -- -score )   linear-2-float-error negate ;

: eat-linear-2-float ( -- )   linear-2-float-error eat-scored ;
' score-linear-2-float  ' eat-linear-2-float  eat-actions 2>list


INDIVIDUAL: linear-2-float ( -- )
' linear-2-float individuals >list

' eat-linear-2-float	eat-xt !
' cell-division	reproduce-xt !
' <look-at>	show-me-xt !
0 my-diversifctn-mask !
1000		reprodctn-threshold !
2		age-threshold !

[THEN]
