\ linear-2.fs

\ ****************************************************************
\ ***************  simple linear equation system  ****************
\ ****************************************************************

\ Compile only if the needed variables are defined:
nuc-organs# 1 >  spot-properties# 2 >  AND [IF]

\ Let's test a simple linear equation system of the form
\ x + a*y = 0
\ x + b*y + c = 0

\ We rate on the added absolute miss of the two equations.

\ The cells have to find out to put the solutions x and y in
\ their first two organs.

\ Parameters a,b,c are spot properties.
\ They will be set randomly each time before the cell is activated.
\ So on each life step the conditions will change heavily and the
\ cells have to find out how to adjust x and y (inner organs A and B )
\ accordingly.


\ So we have:
\ x + a*y = 0
\ x + b*y + c = 0

\ brew sees it like this:
\ x = organ-A		y = organ-B				\ r/w nuc vars
\ a = A-property	b = B-property		c = C-property	\ r/o spot vars

\ organ-A @  A-property @ organ-B @ *  +		 "=0"
\ organ-A @  B-property @ organ-B @ *  +  C-property @ + "=0"
\ 
\ a possible solution ;-)
\ x = ac / (b - a)
\ y = c  / (a - b)
\ 
s" -" GENE: cheat-simple-linear
    A-property@ C-property@ *  B-property@ A-property@ -  ?/  organ-A !
    C-property@  A-property@ B-property@ -  ?/  organ-B ! ;gene

internal' cheat-simple-linear wake-me-actions >list

\ I use 2/  --> less overflow tricks here...
: simple-linear-error ( -- +n )
    organ-A @   organ-B @  A-property@ *  + 2/ abs
    organ-A @	organ-B @  B-property@ *  +  C-property@ +  2/ abs  + ;

: score-simple-linear ( -- -score )   simple-linear-error negate ;

: eat-simple-linear ( -- )   simple-linear-error eat-scored ;
' score-simple-linear  ' eat-simple-linear  eat-actions 2>list


INDIVIDUAL: simple-linear ( -- )
' simple-linear individuals >list

' eat-simple-linear	eat-xt !
' cell-division	reproduce-xt !
' <look-at>	show-me-xt !
div-organ-A div-organ-B or my-diversifctn-mask !
1000		reprodctn-threshold !
2		age-threshold !

[THEN]
