\ 3-sum.fs

\ Defines some words for the '3-sum' experiment.
\ Don't load this directly, load a corresponding initialisation file instead.

false [IF] \ Comment:

    Let's try something very simple:
    The cells must sum up three numbers 'A = B + C + 2*D'
    We rate on the absolute miss.

    In the beginning of the experiment A B C D are small integer numbers.
    They are drifting randomly away from zero.
    Nucs (Cells) that happen to have a small absolute value of
    | B + C + 2*D - A | have an advantage.
    They will get more energy, food or whatever, reproduce earlier and
    increase in number.
    The others tend to disappear.

    But A B C and D are of three very different qualities:

    A and B are part of the nuc.
    They are herditary, and can get varied a bit during reproduction.

    C and D are beyond the control of the nuc,
    they are variables of the virtual spot the nuc is sitting on.

    So a child will normally have similar A and B, but very different
    C and D values than the mother cell.

    The genome starts by doing noop and gets mutatet then.
    While the gene primitives can read all three values A B C and D
    they provide write access only to the A variable.
    Mutation has it's chance to find out that it can manipulate A
    in a way that will be useful for the cell.

    As D and C drift away from zero it becomes more and more important
    to find an effective algoritm how to set A.

    Brew sees A B C and D as follows:
    A is organ-A
    B is parameter-B
    C is (spot) C-property
    D is (spot) D-property
    (I kept the letters A B C and D for mnemonic reasons).

    a possible solution ;-)
    A = B + C + 2*D

    My proposed cheat:
    s" -" GENE: cheat-3-sum   parameter-B@ C-property@ +
    D-property@ 2* +
    organ-A ! ;gene

[THEN] \ End comment, code follows:


\ ****************************************************************
\ **************************  3-sum  *****************************
\ ****************************************************************

\ Compile only if the needed variables are defined:
nuc-organs#  0 >
nuc-parameters# 1 > AND
spot-properties# 3 >  AND [IF]

\ a possible solution:  A = B + C + 2*D
s" -" GENE: cheat-3-sum
    parameter-B@ C-property@ +
    D-property@ + D-property@ +
    organ-A ! ;gene

internal' cheat-3-sum wake-me-actions >list

: score-3-sum ( -- -score )
    parameter-B @ C-property @ + D-property @ 2* + organ-A @ -  abs negate ;

: eat-3-sum ( -- )
    parameter-B @ C-property @ + D-property @ 2* +
    organ-A @ -  abs eat-scored ;
' score-3-sum  ' eat-3-sum  eat-actions 2>list

INDIVIDUAL: sum-3-up ( -- )
' sum-3-up individuals >list

' eat-3-sum	eat-xt !
' cell-division	reproduce-xt !
' <look-at>	show-me-xt !
div-organ-A div-parameter-B or my-diversifctn-mask !
1000		reprodctn-threshold !
2		age-threshold !

s" '3-sum.fs' included.  Load initialisation file or do it by hand." 1 >message

[ELSE]
    bell
    cr .( Compile options not fit for '3-sum.fs'. )
    cr .( See source. )
    cr
    8000 wait-until
[THEN]

\ ****************************************************************
\ end	3-sum
