\ file-tree.fs
\ 	$Id: file-tree.fs,v 1.3 2009-10-11 06:41:29 f Exp $	

\ ****************************************************************
s" basics.fs"		REQUIRED
s" simple-stringbuf.fs"	REQUIRED
s" create-directory.fs"	REQUIRED

[UNDEFINED] file-names-length# [IF]
    decimal 256  CONSTANT file-names-length#        \ defaults to &256
[THEN]


\ ****************************************************************
\ Brews file tree:


\ Maybe create file tree when it's not there already:
TRUE					\ File tree creation defaults to yes
[UNDEFINED] no-create-file-tree AND	\ unless no-create-file-tree


\ The Program will look for inputs relative to input-dir, if the user does not
\ select another directory. Make the string end with a directory separator.
[UNDEFINED] inputs-dir [IF]
    : inputs-dir ( -- addr count )   s" INPUTS/" ;
[THEN]
dup [IF]   inputs-dir ?create-directory   [THEN]


\ Word to put input-dir in front of a subdirectory name:
\ attention: there is only *one* buffer used, don't use multiple strings.
\ Use like this:
\ : experiments-dir ( -- addr count )   s" experiments/" inputs-sub-dir ;
file-names-length# S-BUF: (in-sub-dir)
: inputs-sub-dir ( addr count -- addr' count' )
    (in-sub-dir) >r
    r@ s-buf-clear
    inputs-dir r@ s-buf-cat
    ( addr count ) r@ s-buf-cat
    r> s-buf>string ;


\ The program will put all it's output relative to out-dir, if the user does
\ not select another directory. Make the string end with a directory separator.
[UNDEFINED] out-dir [IF]   : out-dir ( -- addr count )   s" OUTPUT/" ;	[THEN]
dup [IF]   out-dir ?create-directory   [THEN]

\ Word to put out-dir in front of a subdirectory name:
\ attention: there is only *one* buffer used, don't use multiple strings.
file-names-length# S-BUF: (out-sub-dir)
: out-sub-dir ( addr count -- addr' count' )
    (out-sub-dir) >r
    r@ s-buf-clear
    out-dir r@ s-buf-cat
    ( addr count ) r@ s-buf-cat
    r> s-buf>string ;

: tmp-dir ( -- addr count )		s" tmp/"	out-sub-dir ;
dup [IF]   tmp-dir ?create-directory   [THEN]

drop
