\ long-masks.fs

\ Bit arrays possibly longer than one cell.
\ Intended usage is for individual named bits mainly,
\ or for looping over the array and do something switched by the indexed bit.


\ Internally represented as a double cell on stack: ( bit offset )
\ [The compiler could decide to leave the offset away, if only offset=0 used]
\ So do not fiddle with the stack items directly.

\ 8 CONSTANT bits/cell \ ############# JUST FOR A TEST.
32 CONSTANT bits/cell \ #############

: #bit>dindex ( #index -- bit-mask offset )
    bits/cell /mod cells
    swap 1 swap lshift swap ;

\ Test a bit in a long mask:

\ Version taking the internal double cell representation:
: long-AND ( bit-mask offset addr -- flag-not-normalized )  + @ and ;

\ Version taking the bit-index:
: #bit-AND ( bit-index addr -- flag-not-normalized )
    >r #bit>dindex r> long-AND ;


\ Set a bit in a long mask:

\ Version taking the internal double cell representation:
: long-on! ( bit-mask offset addr -- )  + >r  r@ @ or r> ! ;

\ Version taking the bit-index:
: #bit-on! ( bit-index addr -- )   >r #bit>dindex r> long-on! ;


\ Clear a bit in a long mask:

\ Version taking the internal double cell representation:
: long-off! ( bit-mask offset addr -- )  + >r  invert  r@ @ and  r> ! ;

\ Version taking the bit-index:
: #bit-off! ( bit-index addr -- )   >r #bit>dindex r> long-off! ;


\ Defining named bits as 2CONSTANTs giving the internal representation:

: long-MASK: ( compile: bit-index -- bit-index+1 )
    dup #bit>dindex 2CONSTANT ( run:  -- bit offset )
    1+ ;

true [IF]
0
long-MASK: a dup .
long-MASK: b dup .
long-MASK: c dup .
long-MASK: d dup .
long-MASK: e dup .
long-MASK: f dup .
long-MASK: g dup .
long-MASK: h dup .
long-MASK: i dup .
long-MASK: k dup .
long-MASK: l dup .
long-MASK: m dup .
long-MASK: n dup .
long-MASK: o dup .
long-MASK: p dup .
long-MASK: q dup .
long-MASK: r dup .
long-MASK: s dup .
long-MASK: t dup .
long-MASK: u dup .
long-MASK: v dup .
long-MASK: w dup .
long-MASK: x dup .
long-MASK: y dup .
long-MASK: z dup .
long-MASK: b26 dup .
long-MASK: b27 dup .
long-MASK: b28 dup .
long-MASK: b29 dup .
long-MASK: b30 dup .
long-MASK: b31 dup .
long-MASK: b32 dup .
long-MASK: b33 dup .
long-MASK: b34 dup .
long-MASK: b35 dup .
long-MASK: b36 dup . cr cr

drop

[THEN]
