\ blocks-differ?.fs

\ Free 2 buffers and reset file position in '(before)' and '(after)':
: reset-before&after ( d-position-before d-position-after addr1 addr2 -- )
    1 0 DO free ABORT" blocks-differ?: Could not free." LOOP
    (after) @ reposition-file
    ABORT" blocks-differ?: Couldn't reposition (after) file."
    (before) @ reposition-file
    ABORT" blocks-differ?: Couldn't reposition (before) file." ;

\ Read and compare lines from '(before)' and '(after)' files,
\ stop if both files reach the end mark, returning FALSE.
\ If a difference is found reset both file positions and return TRUE.
: blocks-differ? ( -- flag )
    \ remember file positions
    (before) @ file-position
    ABORT" blocks-differ?: Couldn't read '(before)' file position"
    (after) @ file-position
    ABORT" blocks-differ?: Couldn't read '(after)' file position"
    ( d-position-before d-position-after )

    \ allocate two buffers to keep two lines to compare
    file-line-max# allocate
    ABORT" blocks-differ?: Couldn't allocate."
    file-line-max# allocate
    ABORT" blocks-differ?: Couldn't allocate."
    >r		( ... addr-after  r: addr-before )

    BEGIN	( ... addr-after  r: addr-before )
	dup read-after-&-test
    WHILE \ 'after' block line succesfully read in
	( addr-after addr-after count-after  r: addr-before )
	r@ read-before-&-test
	IF	\ 'before' block line succesfully read in
	    compare IF			\ Block line differs!
		r> reset-before&after
		TRUE EXIT			\ Difference found, done.
	    THEN
	ELSE					\ 'before' no more block line
	    ABORT" blocks-differ?: 'before' file EOF inside block."
	    ( addr-after addr-after count-after before-xt  r: addr-before)
	    drop 2drop r> reset-before&after
	    TRUE EXIT				\ 'before' block ends earlier
	THEN
    REPEAT
    ABORT" blocks-differ?: 'after' file EOF inside block."
    ( ... addr-after xt-after  r: addr-before )
    r@ read-before-&-test
    IF	\ 'before' block is longer.
	2drop drop
	r> reset-before&after
	TRUE EXIT
    THEN
    ABORT" blocks-differ?: 'before' file EOF inside block."
    ( ... addr-after xt-after xt-before  r: addr-before )
    <> ABORT" blocks-differ?: end block type mismatch."
    1 0 DO free ABORT" blocks-differ?: Could not free." LOOP
    FALSE ;

\ Compare two blocks, if there's a difference output the entire 'after'
\ block (without delimiters). 
: diff-block-as-unit ( addr-before addr-after -- )
    2drop
    blocks-differ? IF
	(after) @ copy-block-until-end
	EXIT
    THEN ;

