\ frandom.fs

false [IF] \ The algorithm comes from:
    From: Wil Baden <wilbaden@netcom8.netcom.com>
    Newsgroups: comp.lang.forth
    Subject: Re: Millions and Millions of Random Numbers
    Date: 18 May 2000 14:47:54 GMT
    Message-ID: <8g0vqq$mml$1@slb1.atl.mindspring.net>
[THEN]

s" bigFORTH" environment? [IF]
    cr .( we're running bigFORTH ) . 8 emit char . emit . cr    \ version nr
    INCLUDE float.fb
    also FLOAT also FORTH
[THEN]

decimal

VARIABLE random-xt		\ xt of actual random number generator

\ random ( from BRODIE )
VARIABLE seed-BRODIE	here seed-BRODIE !
1075118612 seed-BRODIE !   \ ###### I inserted this to make it reproducable...

: random-BRODIE    seed-BRODIE @ 31421 * 6927 + dup seed-BRODIE ! ;
' random-BRODIE random-xt !


2VARIABLE (random-generalized)
\ generator seed (random-generalized) 2!	\ sets seed and generator
\	    seed (random-generalized) !		\ sets seed only
hex
10450405 0 (random-generalized) 2!
decimal

: random-generalized ( -- n )
    (random-generalized) 2@ swap  um* drop 1+ dup   (random-generalized) ! ;

\ ' random-generalized random-xt !

: FRANDOM  ( F: -- 0. <= r < 1. )
    random-xt @ EXECUTE
    0 D>F 2.3283064365386963E-10 F* ;

: FRANDOM-1  ( F: -- 0. <= r <= 1. )
    random-xt @ EXECUTE
    0 D>F 2.3283064370807974e-10 F* ;

: .tab   9 emit ;

FVARIABLE sum1
FVARIABLE sum2
FVARIABLE sum3

: sum-off ( -- )
    0e0
    fdup sum1 df!
    fdup sum2 df!
    sum3 df! ;

: fdup. ( r -- r )  fdup f. ;

: f+! ( r addr -- )
    >r
    r@ df@ f+ r> df! ;

: t ( u -- )
    sum-off
    0 ?DO
	cr
	FRANDOM fdup.
	sum1 f+!
	.tab
	FRANDOM-1 fdup.
	sum2 f+!
	.tab
	FRANDOM-1 fdup.
	sum3 f+!
    LOOP
    cr cr
    sum1 df@ f. .tab
    sum2 df@ f. .tab
    sum3 df@ f. .tab
    cr ;

: tt ( u -- )
    sum-off
    cr
    dup 0 ?DO
	FRANDOM	  sum1 f+!
	FRANDOM-1 sum2 f+!
	FRANDOM-1 sum3 f+!
    LOOP
    sum1 df@ f. .tab
    sum2 df@ f. .tab
    sum3 df@ f. .tab
    cr

    s>d d>f
    sum1 df@ fover f/ f. .tab
    sum2 df@ fover f/ f. .tab
    sum3 df@ fswap f/ f. .tab
    cr ;

18 set-precision

false [IF]

    ANS bigFORTH 386-Linux rev. 2.0.5

100000000 tt
50002073.0705577955     50002475.7298715785     50003554.5804289058
0.50002073070557795     0.50002475729871579     0.50003554580428906


GForth 0.5.0, Copyright (C) 1995-2000 Free Software Foundation, Inc.

100000000 tt
50002073.070557795      50002475.729871581      50003554.580428906
.50002073070557795      .50002475729871581      .50003554580428915


\ Portable Forth Environment 0.30.97 (Jul 13 2001 17:10:17)
100000000 tt
50002073.070557795464992523     50002475.729871578514575958     50003554.580428905785083771
0.500020730705577954    0.500024757298715761    0.500035545804289105

[THEN]

FVARIABLE max0
FVARIABLE max1

: .max ( -- )
    cr    max0 df@ f.
    .tab  max1 df@ f.
    .tab  max1 df@  max0 df@  f- f. ;

: tmax ( -- )
    0e0  fdup max0 df!  max1 df!
    cr
    BEGIN

	FRANDOM
	fdup max0 df@ f> IF
	    max0 df!
	    .max
	ELSE
	    fdrop
	THEN

	FRANDOM-1
	fdup max1 df@ f> IF
	    max1 df!
	    .max
	ELSE
	    fdrop
	THEN
	
    AGAIN ;
