\ conditionals.fs
\ 	$Id: conditionals.fs,v 1.5 2009-10-20 16:09:20 f Exp $	


VARIABLE conditional-token-price
(default-gene-cost#) 3 / conditional-token-price !	\ just a default

\ Define stubs for 'if' 'else' 'then' and '[if]' '[else]' '[then]'
\ (They just lend their name for the real ones).
get-current  also stubs definitions
previous	\ we must hide stub ';'
[UNDEFINED] original-: [IF] \ normal case ':' ';' not redefined:
: IF ;
: ELSE ;
: THEN ;
[ELSE] \ ':' ';' have been replaced (profiling): we must use the original ones.
    original-: IF   ;-original
    original-: ELSE ;-original
    original-: THEN ;-original
[THEN]
set-current

get-current
also genes definitions  also stubs

s" C-" ' IF as-gene
internal' IF >body
' [IF]  over >gene-evaluated-xt !
conditional-token-price @ over >gene-cost !
>gene-flags dup @ frame-pushing or swap !    

s" -" ' ELSE as-gene
internal' ELSE >body
' [ELSE]  over >gene-evaluated-xt !
conditional-token-price @ over >gene-cost !
>gene-flags dup @ frame-popping or frame-pushing or swap !    

s" -" ' THEN as-gene
internal' THEN >body
' [THEN]  over >gene-evaluated-xt !
conditional-token-price @ over >gene-cost !
>gene-flags dup @ frame-popping or swap !    

previous  previous  set-current


[DEFINED] 32bit-64 [IF]		\ running 32bit benchmark on 64bit system
    also 32-64-words		\ redefining 0= 0< 0> = > < within   maybe more
[THEN]

\ Condidional genes that can log input and output.
\ I need these to debug 32bit benchmarks running on 64bit systems. ;)
log-mask @ 0> [IF] \ extension compiling extensive extra loging information

    get-current
    also genes definitions

    : 0= ( n -- flag )
	log-ext? IF
	    s" 0= in: "				cat-log
	    dup num>string			cat-log
	    0=
	    s" 	out: "				cat-log
	    dup IF s" true" ELSE s" false" THEN	do-log-it
	ELSE
	    0=
	THEN ;

    : 0> ( n -- flag )
	log-ext? IF
	    s" 0> in: "				cat-log
	    dup num>string			cat-log
	    0>
	    s" 	out: "				cat-log
	    dup IF s" true" ELSE s" false" THEN	do-log-it
	ELSE
	    0>
	THEN ;

    : 0< ( n -- flag )
	log-ext? IF
	    s" 0< in: "				cat-log
	    dup num>string			cat-log
	    0<
	    s" 	out: "				cat-log
	    dup IF s" true" ELSE s" false" THEN	do-log-it
	ELSE
	    0<
	THEN ;

    : = ( n -- flag )
	log-ext? IF
	    s" = in: "			cat-log
	    over num>string		cat-log
	    s" 	"			cat-log
	    dup num>string		cat-log
	    =
	    s" 	out: "			cat-log
	    dup IF s" true" ELSE s" false" THEN  do-log-it
	ELSE
	    =
	THEN ;

    : > ( n -- flag )
	log-ext? IF
	    s" > in: "			cat-log
	    over num>string		cat-log
	    s" 	"			cat-log
	    dup num>string		cat-log
	    >
	    s" 	out: "			cat-log
	    dup IF s" true" ELSE s" false" THEN  do-log-it
	ELSE
	    >
	THEN ;

    : < ( n -- flag )
	log-ext? IF
	    s" < in: "			cat-log
	    over num>string		cat-log
	    s" 	"			cat-log
	    dup num>string		cat-log
	    <
	    s" 	out: "			cat-log
	    dup IF s" true" ELSE s" false" THEN  do-log-it
	ELSE
	    <
	THEN ;

    set-current
[THEN]

s" n-C"		' 0=	 as-gene
2000 to-gene-pool' 0=

s" n-C"		' 0<	 GENE-ALIAS: 0<
5000 to-gene-pool' 0<

s" n-C"		' 0>	 GENE-ALIAS: 0>
5000 to-gene-pool' 0>

s" nn-C"	' = 	 GENE-ALIAS: =
1000 to-gene-pool' =

s" nn-C"	' >	 GENE-ALIAS: >
10000 to-gene-pool' >

s" nn-C"	' <	 GENE-ALIAS: <
10000 to-gene-pool' <

s" nnn-C"	' within GENE-ALIAS: within
8000 to-gene-pool' within

log-mask @ 0> [IF]
    previous
[THEN]

[DEFINED] 32bit-64 [IF]
    previous
[THEN]


s" CC-C"	' AND	 GENE-ALIAS: AND
10000 to-gene-pool' AND

s" CC-C"	' OR	 GENE-ALIAS: OR
10000 to-gene-pool' OR

s" CC-C"	' XOR	 GENE-ALIAS: XOR
10000 to-gene-pool' XOR

\ g-IF-ELSE-THEN is a pseudo gen, which is never executed,
\ but triggers insertion of a IF ELSE THEN structure.
get-current  also genes definitions
: g-IF-ELSE-THEN ;
s" C-"  ' g-IF-ELSE-THEN  as-gene
internal' g-IF-ELSE-THEN >body >gene-flags dup @ special building or or swap !
10000 to-gene-pool' g-IF-ELSE-THEN
previous  set-current
