\ store-normalised.fs
\ 	$Id: store-normalised.fs,v 1.5 2009-10-22 06:12:04 f Exp $	

\ simple attempt to scale and/or normalize integer values
\ to deal with integer overflow when adding and so.

decimal
1024 VALUE gene-normalize-max		\ VALUE's are faster than variables

\ some
\ a word to normalize integers somehow
gene-normalize-max 2/ VALUE gene-normalize/2
gene-normalize/2   2/ VALUE gene-normalize/4

[DEFINED] 32bit-64 [IF]		  \ running 32bit benchmark on 64bit system
    also 32-64-words
[THEN]

: some ( n -- n' )
[DEFINED] 32bit-64 [IF]		  \ running 32bit benchmark on 64bit system
    32>64bit
[THEN]
[ log-mask @ 0> ] [IF] \ compiling extended logging capabilities
    log-mask @ IF \ speed
	log-ext? IF
	    s" some before: " cat-log
	    dup
[DEFINED] 32bit-64 [IF]           \ running 32bit benchmark on 64bit system
    [ base @ hex ]
            FFFFFFFF and	  \ keep only 32bits   allow diff to work right
    [ base ! ]
[THEN]
	    hex-u-num>string	cat-log		\ continued...
	THEN
    THEN
[THEN]

    dup 0< >r	( n  r: sign )

    abs
    dup gene-normalize/2 > IF
	2/ gene-normalize/4 +		\ increases half as steep
	abs gene-normalize-max min	\ just cut at abs gene-normalize-max
    THEN

    r> IF negate THEN

[ log-mask @ 0> ] [IF] \ compiling extended logging capabilities
    log-mask @ IF \ speed
	log-ext? IF
	    s" 	some after:  "		cat-log
	    dup
[DEFINED] 32bit-64 [IF]           \ running 32bit benchmark on 64bit system
    [ base @ hex ]
            FFFFFFFF and	  \ keep only 32bits   allow diff to work right
    [ base ! ]
[THEN]
	    do-log-hex-u-num
	THEN
    THEN
[THEN]
;

[DEFINED] 32bit-64 [IF]
    previous
[THEN]

: $$ ( n X -- n' X )   >r some r> ;	\ normalizes *second* stack item

get-current  also genes  definitions

: !(some) ( n a -- )   $$ ! ;
s" na-"  ' !(some)  as-gene
10000 to-gene-pool' !(some)

: +!(some) ( n a -- )  $$ +! ;
s" na-"  ' +!(some)  as-gene
10000 to-gene-pool' +!(some)

: -!(some) ( n a -- )  swap some negate swap +! ;
s" na-"  ' -!(some)  as-gene
10000 to-gene-pool' -!(some)

: swap!(some) ( a n -- )   some swap ! ;
s" an-"  ' swap!(some)  as-gene
10000 to-gene-pool' swap!(some)

\ ok, it's not storing but fetching, but might be interesting anyway:
\ taking an normalized amount off at a spezified address.
: take-some ( a -- n )   dup >r @ some dup negate r> +! ;
s" a-n"  ' take-some  as-gene
10000 to-gene-pool' take-some

previous  set-current
